<?php if (!defined('ROOTPATH')) exit('No direct script access allowed'); ?>
<?php
// Execute the deferred query and group the case assocs by the cases
// for easy and fast lookup
$case_assocs = group::by_id($case_assocs->result(), 'case_id');
?>
<?php $section = $sections->peek() ?>
<?php while ($section): ?>
<?php $sections->next() ?>
<?php $test = $tests->peek() ?>
<?php while ($test && $test->section_id == $section->id): ?>
<?php $tests->next() ?>
<?php if (isset($case_assocs[$test->content_id])): ?>
<?php $current_case_assocs = group::by_id_scalar(
	$case_assocs[$test->content_id]->items,
	'name',
	'value') ?>
<?php foreach ($current_case_assocs as $key => $value): ?>
<?php $test->$key = $value ?>
<?php endforeach ?>
<?php endif ?>
<?php
$last_update = null;
$current_test_changes = array();

$change = $test_changes->peek();
while ($change && $change->test_id == $test->id)
{
	$test_changes->next();
	$current_test_changes[] = $change;

	if ($change->status_id)
	{
		if (!$last_update) // Iterated in reverse order
		{
			$last_update = $change->created_on;
		}
	}

	$change = $test_changes->peek();	
}

if ($current_test_changes)
{
	$elapsed = tests::get_elapsed($current_test_changes);
	$defects = tests::get_defects($current_test_changes);
}
else
{
	$elapsed = null;
	$defects = null;
}

$milestone = null;
if ($test->milestone_id)
{
	$milestone = arr::get($milestone_lookup, $test->milestone_id);
}
?>
<?php echo  csv::join(
	array_merge(
		array(
			entities::test_id($test->id),
			csv::encode($test->title),
			csv::encode(
				$GI->cache->get_scalar(
					'case_type',
					$test->type_id,
					'name',
					''
				)
			),
			csv::encode(
				$GI->cache->get_scalar(
					'priority',
					$test->priority_id,
					'name',
					''
				)
			),
			csv::encode($test->estimate),
			csv::encode($milestone ? $milestone->name : ''),
			csv::encode(references::format_nolinks($test->refs))
		),
		obj::get_fields(
			fields::export_values($case_fields, $test, $exporter, true),
			'value'
		),
		array(
			csv::encode($section->name),
			csv::encode($section->depth),
			entities::case_id($test->case_id),
			csv::encode(tests::get_status_name($test->status_id)),
			csv::encode(
				$test->assignedto_id ? 
					$GI->cache->get_scalar(
						'user',
						$test->assignedto_id,
						'name',
						''
					) : ''
			),
			csv::encode(
				($test->in_progress_by ? 
					$GI->cache->get_scalar(
						'user',
						$test->in_progress_by,
						'name',
						''
					) : '') . 
				($test->in_progress > 1
					? (' (+' . ($test->in_progress - 1) . ' more)') 
					: '')
			),
			$elapsed ? $elapsed : null,
			csv::encode(defects::format_nolinks($defects)),
			$last_update ? csv::format_datetime($last_update) : null,
			csv::encode($run->name),
			csv::encode($run->config)
		)
	),
	$separator
) ?>
<?php $test = $tests->peek() ?>
<?php endwhile ?>
<?php $section = $sections->peek() ?>
<?php endwhile ?>